of: overlay: enable of_overlay_fdt_apply() kerneldoc
[linux.git] / scripts / faddr2line
1 #!/bin/bash
2 # SPDX-License-Identifier: GPL-2.0
3 #
4 # Translate stack dump function offsets.
5 #
6 # addr2line doesn't work with KASLR addresses.  This works similarly to
7 # addr2line, but instead takes the 'func+0x123' format as input:
8 #
9 #   $ ./scripts/faddr2line ~/k/vmlinux meminfo_proc_show+0x5/0x568
10 #   meminfo_proc_show+0x5/0x568:
11 #   meminfo_proc_show at fs/proc/meminfo.c:27
12 #
13 # If the address is part of an inlined function, the full inline call chain is
14 # printed:
15 #
16 #   $ ./scripts/faddr2line ~/k/vmlinux native_write_msr+0x6/0x27
17 #   native_write_msr+0x6/0x27:
18 #   arch_static_branch at arch/x86/include/asm/msr.h:121
19 #    (inlined by) static_key_false at include/linux/jump_label.h:125
20 #    (inlined by) native_write_msr at arch/x86/include/asm/msr.h:125
21 #
22 # The function size after the '/' in the input is optional, but recommended.
23 # It's used to help disambiguate any duplicate symbol names, which can occur
24 # rarely.  If the size is omitted for a duplicate symbol then it's possible for
25 # multiple code sites to be printed:
26 #
27 #   $ ./scripts/faddr2line ~/k/vmlinux raw_ioctl+0x5
28 #   raw_ioctl+0x5/0x20:
29 #   raw_ioctl at drivers/char/raw.c:122
30 #
31 #   raw_ioctl+0x5/0xb1:
32 #   raw_ioctl at net/ipv4/raw.c:876
33 #
34 # Multiple addresses can be specified on a single command line:
35 #
36 #   $ ./scripts/faddr2line ~/k/vmlinux type_show+0x10/45 free_reserved_area+0x90
37 #   type_show+0x10/0x2d:
38 #   type_show at drivers/video/backlight/backlight.c:213
39 #
40 #   free_reserved_area+0x90/0x123:
41 #   free_reserved_area at mm/page_alloc.c:6429 (discriminator 2)
42
43
44 set -o errexit
45 set -o nounset
46
47 usage() {
48         echo "usage: faddr2line [--list] <object file> <func+offset> <func+offset>..." >&2
49         exit 1
50 }
51
52 warn() {
53         echo "$1" >&2
54 }
55
56 die() {
57         echo "ERROR: $1" >&2
58         exit 1
59 }
60
61 UTIL_SUFFIX=""
62 if [[ "${LLVM:-}" == "" ]]; then
63         UTIL_PREFIX=${CROSS_COMPILE:-}
64 else
65         UTIL_PREFIX=llvm-
66
67         if [[ "${LLVM}" == *"/" ]]; then
68                 UTIL_PREFIX=${LLVM}${UTIL_PREFIX}
69         elif [[ "${LLVM}" == "-"* ]]; then
70                 UTIL_SUFFIX=${LLVM}
71         fi
72 fi
73
74 READELF="${UTIL_PREFIX}readelf${UTIL_SUFFIX}"
75 ADDR2LINE="${UTIL_PREFIX}addr2line${UTIL_SUFFIX}"
76 AWK="awk"
77 GREP="grep"
78
79 command -v ${AWK} >/dev/null 2>&1 || die "${AWK} isn't installed"
80 command -v ${READELF} >/dev/null 2>&1 || die "${READELF} isn't installed"
81 command -v ${ADDR2LINE} >/dev/null 2>&1 || die "${ADDR2LINE} isn't installed"
82
83 # Try to figure out the source directory prefix so we can remove it from the
84 # addr2line output.  HACK ALERT: This assumes that start_kernel() is in
85 # init/main.c!  This only works for vmlinux.  Otherwise it falls back to
86 # printing the absolute path.
87 find_dir_prefix() {
88         local objfile=$1
89
90         local start_kernel_addr=$(${READELF} --symbols --wide $objfile | sed 's/\[.*\]//' |
91                 ${AWK} '$8 == "start_kernel" {printf "0x%s", $2}')
92         [[ -z $start_kernel_addr ]] && return
93
94         local file_line=$(${ADDR2LINE} -e $objfile $start_kernel_addr)
95         [[ -z $file_line ]] && return
96
97         local prefix=${file_line%init/main.c:*}
98         if [[ -z $prefix ]] || [[ $prefix = $file_line ]]; then
99                 return
100         fi
101
102         DIR_PREFIX=$prefix
103         return 0
104 }
105
106 __faddr2line() {
107         local objfile=$1
108         local func_addr=$2
109         local dir_prefix=$3
110         local print_warnings=$4
111
112         local sym_name=${func_addr%+*}
113         local func_offset=${func_addr#*+}
114         func_offset=${func_offset%/*}
115         local user_size=
116         local file_type
117         local is_vmlinux=0
118         [[ $func_addr =~ "/" ]] && user_size=${func_addr#*/}
119
120         if [[ -z $sym_name ]] || [[ -z $func_offset ]] || [[ $sym_name = $func_addr ]]; then
121                 warn "bad func+offset $func_addr"
122                 DONE=1
123                 return
124         fi
125
126         # vmlinux uses absolute addresses in the section table rather than
127         # section offsets.
128         local file_type=$(${READELF} --file-header $objfile |
129                 ${AWK} '$1 == "Type:" { print $2; exit }')
130         if [[ $file_type = "EXEC" ]] || [[ $file_type == "DYN" ]]; then
131                 is_vmlinux=1
132         fi
133
134         # Go through each of the object's symbols which match the func name.
135         # In rare cases there might be duplicates, in which case we print all
136         # matches.
137         while read line; do
138                 local fields=($line)
139                 local sym_addr=0x${fields[1]}
140                 local sym_elf_size=${fields[2]}
141                 local sym_sec=${fields[6]}
142                 local sec_size
143                 local sec_name
144
145                 # Get the section size:
146                 sec_size=$(${READELF} --section-headers --wide $objfile |
147                         sed 's/\[ /\[/' |
148                         ${AWK} -v sec=$sym_sec '$1 == "[" sec "]" { print "0x" $6; exit }')
149
150                 if [[ -z $sec_size ]]; then
151                         warn "bad section size: section: $sym_sec"
152                         DONE=1
153                         return
154                 fi
155
156                 # Get the section name:
157                 sec_name=$(${READELF} --section-headers --wide $objfile |
158                         sed 's/\[ /\[/' |
159                         ${AWK} -v sec=$sym_sec '$1 == "[" sec "]" { print $2; exit }')
160
161                 if [[ -z $sec_name ]]; then
162                         warn "bad section name: section: $sym_sec"
163                         DONE=1
164                         return
165                 fi
166
167                 # Calculate the symbol size.
168                 #
169                 # Unfortunately we can't use the ELF size, because kallsyms
170                 # also includes the padding bytes in its size calculation.  For
171                 # kallsyms, the size calculation is the distance between the
172                 # symbol and the next symbol in a sorted list.
173                 local sym_size
174                 local cur_sym_addr
175                 local found=0
176                 while read line; do
177                         local fields=($line)
178                         cur_sym_addr=0x${fields[1]}
179                         local cur_sym_elf_size=${fields[2]}
180                         local cur_sym_name=${fields[7]:-}
181
182                         # is_mapping_symbol(cur_sym_name)
183                         if [[ ${cur_sym_name} =~ ^(\.L|L0|\$) ]]; then
184                                 continue
185                         fi
186
187                         if [[ $cur_sym_addr = $sym_addr ]] &&
188                            [[ $cur_sym_elf_size = $sym_elf_size ]] &&
189                            [[ $cur_sym_name = $sym_name ]]; then
190                                 found=1
191                                 continue
192                         fi
193
194                         if [[ $found = 1 ]]; then
195                                 sym_size=$(($cur_sym_addr - $sym_addr))
196                                 [[ $sym_size -lt $sym_elf_size ]] && continue;
197                                 found=2
198                                 break
199                         fi
200                 done < <(${READELF} --symbols --wide $objfile | sed 's/\[.*\]//' | ${AWK} -v sec=$sym_sec '$7 == sec' | sort --key=2)
201
202                 if [[ $found = 0 ]]; then
203                         warn "can't find symbol: sym_name: $sym_name sym_sec: $sym_sec sym_addr: $sym_addr sym_elf_size: $sym_elf_size"
204                         DONE=1
205                         return
206                 fi
207
208                 # If nothing was found after the symbol, assume it's the last
209                 # symbol in the section.
210                 [[ $found = 1 ]] && sym_size=$(($sec_size - $sym_addr))
211
212                 if [[ -z $sym_size ]] || [[ $sym_size -le 0 ]]; then
213                         warn "bad symbol size: sym_addr: $sym_addr cur_sym_addr: $cur_sym_addr"
214                         DONE=1
215                         return
216                 fi
217
218                 sym_size=0x$(printf %x $sym_size)
219
220                 # Calculate the address from user-supplied offset:
221                 local addr=$(($sym_addr + $func_offset))
222                 if [[ -z $addr ]] || [[ $addr = 0 ]]; then
223                         warn "bad address: $sym_addr + $func_offset"
224                         DONE=1
225                         return
226                 fi
227                 addr=0x$(printf %x $addr)
228
229                 # If the user provided a size, make sure it matches the symbol's size:
230                 if [[ -n $user_size ]] && [[ $user_size -ne $sym_size ]]; then
231                         [[ $print_warnings = 1 ]] &&
232                                 echo "skipping $sym_name address at $addr due to size mismatch ($user_size != $sym_size)"
233                         continue;
234                 fi
235
236                 # Make sure the provided offset is within the symbol's range:
237                 if [[ $func_offset -gt $sym_size ]]; then
238                         [[ $print_warnings = 1 ]] &&
239                                 echo "skipping $sym_name address at $addr due to size mismatch ($func_offset > $sym_size)"
240                         continue
241                 fi
242
243                 # In case of duplicates or multiple addresses specified on the
244                 # cmdline, separate multiple entries with a blank line:
245                 [[ $FIRST = 0 ]] && echo
246                 FIRST=0
247
248                 echo "$sym_name+$func_offset/$sym_size:"
249
250                 # Pass section address to addr2line and strip absolute paths
251                 # from the output:
252                 local args="--functions --pretty-print --inlines --exe=$objfile"
253                 [[ $is_vmlinux = 0 ]] && args="$args --section=$sec_name"
254                 local output=$(${ADDR2LINE} $args $addr | sed "s; $dir_prefix\(\./\)*; ;")
255                 [[ -z $output ]] && continue
256
257                 # Default output (non --list):
258                 if [[ $LIST = 0 ]]; then
259                         echo "$output" | while read -r line
260                         do
261                                 echo $line
262                         done
263                         DONE=1;
264                         continue
265                 fi
266
267                 # For --list, show each line with its corresponding source code:
268                 echo "$output" | while read -r line
269                 do
270                         echo
271                         echo $line
272                         n=$(echo $line | sed 's/.*:\([0-9]\+\).*/\1/g')
273                         n1=$[$n-5]
274                         n2=$[$n+5]
275                         f=$(echo $line | sed 's/.*at \(.\+\):.*/\1/g')
276                         ${AWK} 'NR>=strtonum("'$n1'") && NR<=strtonum("'$n2'") { if (NR=='$n') printf(">%d<", NR); else printf(" %d ", NR); printf("\t%s\n", $0)}' $f
277                 done
278
279                 DONE=1
280
281         done < <(${READELF} --symbols --wide $objfile | sed 's/\[.*\]//' | ${AWK} -v fn=$sym_name '$8 == fn')
282 }
283
284 [[ $# -lt 2 ]] && usage
285
286 objfile=$1
287
288 LIST=0
289 [[ "$objfile" == "--list" ]] && LIST=1 && shift && objfile=$1
290
291 [[ ! -f $objfile ]] && die "can't find objfile $objfile"
292 shift
293
294 ${READELF} --section-headers --wide $objfile | ${GREP} -q '\.debug_info' || die "CONFIG_DEBUG_INFO not enabled"
295
296 DIR_PREFIX=supercalifragilisticexpialidocious
297 find_dir_prefix $objfile
298
299 FIRST=1
300 while [[ $# -gt 0 ]]; do
301         func_addr=$1
302         shift
303
304         # print any matches found
305         DONE=0
306         __faddr2line $objfile $func_addr $DIR_PREFIX 0
307
308         # if no match was found, print warnings
309         if [[ $DONE = 0 ]]; then
310                 __faddr2line $objfile $func_addr $DIR_PREFIX 1
311                 warn "no match for $func_addr"
312         fi
313 done